#pragma once

#ifndef __FramesFromFileSourceFilter__
#define __FramesFromFileSourceFilter__

#pragma warning(disable : 4995)

#include <streams.h>
#include <iostream>
#include <fstream>
#include <sstream>
#include <time.h>
#include <process.h>
#include <sys/stat.h>

#include "Guids.h"

using namespace std;

// Filter name strings
#define g_wszFramesFromFileSourceFilter	L"Frames From File Source Filter"

// H264 Subtype GUID Definition
class DECLSPEC_UUID("34363248-0000-0010-8000-00AA00389B71") Subtype_H264;
 
/**********************************************
 *
 *  Class declarations
 *
 **********************************************/

class FramesFromFilePin : public CSourceStream
{
protected:
	HANDLE m_hFramesFromFileStreamThreadHandle;
	unsigned int m_dwThreadID;

	virtual HRESULT OnThreadCreate();
	virtual HRESULT OnThreadDestroy();
	virtual HRESULT DoBufferProcessingLoop();
public:

    FramesFromFilePin(HRESULT *phr, CSource *pFilter);
    ~FramesFromFilePin();

    HRESULT GetMediaType(CMediaType *pMediaType);
    HRESULT DecideBufferSize(IMemAllocator *pAlloc, ALLOCATOR_PROPERTIES *pRequest);
    HRESULT FillBuffer(IMediaSample *pSample);

    STDMETHODIMP Notify(IBaseFilter *pSelf, Quality q)
    {
        return E_FAIL;
    }

private:
	BITMAPINFOHEADER m_bmpInfo;

	struct stat results;
	int frameNumber;
	int fileSize;
	int i;
	char file[MAX_PATH];
	std::stringstream ss;
	std::string zeroPaddedNumber;
	std::string path;
	std::string filename;
	ifstream myFile;

	REFERENCE_TIME m_rtStart;
	REFERENCE_TIME m_rtEnd;
};

class FramesFromFileSourceFilter : public CSource
{

private:
    FramesFromFileSourceFilter(IUnknown *pUnk, HRESULT *phr);
    ~FramesFromFileSourceFilter();

	FramesFromFilePin *m_pPin;

public:
	DECLARE_IUNKNOWN;

    static CUnknown * WINAPI CreateInstance(IUnknown *pUnk, HRESULT *phr);  

	STDMETHODIMP NonDelegatingQueryInterface(REFIID riid, void **ppv);
};

#endif